-- Landmine.applescript
-- Landmine

--  Created by Jonathan Nathan on Fri Aug 22 2003.
--  Copyright (c) 2003 by Jonathan Nathan. All rights reserved.

property x : 3
property y : 3
property min : 1
property max : 5
property the_move : 1

property mine_location : {3, 3}
property treasure_location : {3, 3}

property the_matrix : {{x:1, y:1, description:"The description of what you see..."}, {x:2, y:1, description:"The description of what you see..."}, {x:3, y:1, description:"The description of what you see..."}, {x:4, y:1, description:"The description of what you see..."}, {x:5, y:1, description:"The description of what you see..."}, {x:1, y:2, description:"The description of what you see..."}, {x:2, y:2, description:"The description of what you see..."}, {x:3, y:2, description:"The description of what you see..."}, {x:4, y:2, description:"The description of what you see..."}, {x:5, y:2, description:"The description of what you see..."}, {x:1, y:3, description:"The description of what you see..."}, {x:2, y:3, description:"The description of what you see..."}, {x:3, y:3, description:"The description of what you see..."}, {x:4, y:3, description:"The description of what you see..."}, {x:5, y:3, description:"The description of what you see..."}, {x:1, y:4, description:"The description of what you see..."}, {x:2, y:4, description:"The description of what you see..."}, {x:3, y:4, description:"The description of what you see..."}, {x:4, y:4, description:"The description of what you see..."}, {x:5, y:4, description:"The description of what you see..."}, {x:1, y:5, description:"The description of what you see..."}, {x:2, y:5, description:"The description of what you see..."}, {x:3, y:5, description:"The description of what you see..."}, {x:4, y:5, description:"The description of what you see..."}, {x:5, y:5, description:"The description of what you see..."}}

on launched the_object
	log "launched"
	my reset_game()
end launched

on should quit after last window closed the_object
	return true
end should quit after last window closed

on clicked the_object
	set object_name to name of the_object as string
	log ("user clicked " & object_name)
	
	if object_name = "quit" then
		quit
	else if object_name = "about" then
		display dialog "Landmine v1.0" & return & "by Jonathan Nathan" buttons {"OK"} default button 1 with icon 1 giving up after 10
	else if object_name = "restart" then
		my reset_game()
	else if object_name = "north" then
		set x to (x + 1)
	else if object_name = "south" then
		set x to (x - 1)
	else if object_name = "east" then
		set y to (y + 1)
	else if object_name = "west" then
		set y to (y - 1)
	end if
	if {"north", "south", "east", "west"} contains object_name then
		log "moved to {" & x & ", " & y & "}"
		set the_location to ""
		tell window "main"
			if x = max then
				set enabled of button "north" to false
				set the_location to the_location & " You are as far North as you can go."
			else
				set enabled of button "north" to true
			end if
			if x = min then
				set enabled of button "south" to false
				set the_location to the_location & " You are as far South as you can go."
			else
				set enabled of button "south" to true
			end if
			if y = max then
				set enabled of button "east" to false
				set the_location to the_location & " You are as far East as you can go."
			else
				set enabled of button "east" to true
			end if
			if y = min then
				set enabled of button "west" to false
				set the_location to the_location & " You are as far West as you can go."
			else
				set enabled of button "west" to true
			end if
			
			if mine_location = {x, y} then
				set image of image view ((x as string) & (y as string)) to load image ("red_" & (x as string) & (y as string))
				set description to "Boom! You found the mine."
				set enabled of button "north" to false
				set enabled of button "south" to false
				set enabled of button "east" to false
				set enabled of button "west" to false
			else if treasure_location = {x, y} then
				set image of image view ((x as string) & (y as string)) to load image ("gold_" & (x as string) & (y as string))
				set description to "Hooray! You found the treasure."
				set enabled of button "north" to false
				set enabled of button "south" to false
				set enabled of button "east" to false
				set enabled of button "west" to false
			else
				set image of image view ((x as string) & (y as string)) to load image ("green_" & (x as string) & (y as string))
				repeat with i from 1 to (count of the_matrix)
					set the_record to item i of the_matrix
					if (x of the_record) = x and (y of the_record) = y then
						set description to (description of the_record) & the_location
						exit repeat
					end if
				end repeat
			end if
			my update_text(((the_move as string) & ". " & description), false)
			set the_move to (the_move + 1)
		end tell
		
	end if
end clicked

on reset_game()
	log "resetting game"
	copy {3, 3, 1} to {x, y, the_move}
	repeat
		set mine_location to {(random number from min to max), (random number from min to max)}
		if mine_location  {x, y} then exit repeat
	end repeat
	repeat
		set treasure_location to {(random number from min to max), (random number from min to max)}
		if treasure_location  {x, y} and treasure_location  mine_location then exit repeat
	end repeat
	tell window "main"
		set enabled of button "north" to true
		set enabled of button "south" to true
		set enabled of button "east" to true
		set enabled of button "west" to true
	end tell
	my reset_map()
	my update_text("You are in the middle of the world, try to locate the treasure without finding the mine.", true)
end reset_game

on update_text(the_string, reset_all)
	log "updating text"
	tell window "main"
		tell text view 1 of scroll view "main"
			if reset_all = true then
				set contents to the_string
			else
				set old_text to contents & return
				set contents to old_text & the_string
				set all_text to contents
				set the_length to (length of all_text)
				call method "scrollRangeToVisible:" of object it with parameter {the_length, the_length}
			end if
		end tell
	end tell
end update_text

on reset_map()
	tell window "main"
		repeat with x from 1 to 5
			repeat with y from 1 to 5
				set image of image view ((x as string) & (y as string)) to load image ("grey_" & (x as string) & (y as string))
			end repeat
		end repeat
		set image of image view "33" to load image "green_33"
	end tell
end reset_map